Index: /extensions/Subscribe_to_comments/include/functions.inc.php
===================================================================
--- /extensions/Subscribe_to_comments/include/functions.inc.php	(revision 26138)
+++ /extensions/Subscribe_to_comments/include/functions.inc.php	(revision 26139)
@@ -1,6 +1,4 @@
 <?php
-if (!defined('SUBSCRIBE_TO_PATH')) die('Hacking attempt!');
-
-include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
+defined('SUBSCRIBE_TO_PATH') or die('Hacking attempt!');
 
 /**
@@ -10,12 +8,12 @@
 function send_comment_to_subscribers($comm)
 {
-  if ( empty($comm) or !is_array($comm) )
-  {
-    trigger_error('send_comment_to_subscribers: undefineded comm', E_USER_WARNING);
-    return false;
-  }
-  
+  if (empty($comm) or !is_array($comm))
+  {
+    trigger_error('send_comment_to_subscribers: undefined comm', E_USER_WARNING);
+    return false;
+  }
+
   global $conf, $page, $user, $template;
-  
+
   // create search clauses
   $where_clauses = array();
@@ -24,8 +22,11 @@
     $element_id = $comm['image_id'];
     $element_type = 'image';
-    
-    array_push($where_clauses, 'type = "image" AND element_id = '.$element_id.'');
-    if (!empty($page['category']['id'])) array_push($where_clauses, 'type = "album-images" AND element_id = '.$page['category']['id'].'');
-    array_push($where_clauses, 'type = "all-images"');
+
+    $where_clauses[] = '(type = "image" AND element_id = '.$element_id.')';
+    $where_clauses[] = 'type = "all-images"';
+    if (!empty($page['category']['id']))
+    {
+      $where_clauses[] = '(type = "album-images" AND element_id = '.$page['category']['id'].')';
+    }
   }
   else if (isset($comm['category_id']))
@@ -33,7 +34,7 @@
     $element_id = $comm['category_id'];
     $element_type = 'category';
-    
-    array_push($where_clauses, 'type = "album" AND element_id = '.$element_id.'');
-    array_push($where_clauses, 'type = "all-albums"');
+
+    $where_clauses[] = '(type = "album" AND element_id = '.$element_id.')';
+    $where_clauses[] = 'type = "all-albums"';
   }
   else
@@ -41,5 +42,5 @@
     return;
   }
-  
+
   // exclude current user
   $exclude = null;
@@ -52,5 +53,5 @@
     $exclude = $user['email'];
   }
-  
+
   // get subscribers datas
   $query = '
@@ -61,15 +62,19 @@
   FROM '.SUBSCRIBE_TO_TABLE.'
   WHERE (
-      ('.implode(")\n      OR (", $where_clauses).')
+      '.implode("\n      OR ", $where_clauses).'
     )
     AND validated = true
     AND email != "'.$exclude.'"
+  GROUP BY email
 ';
-  $subscriptions = hash_from_query($query, 'id');
-  
-  if (count($subscriptions)==0) return;
-  
+  $subscriptions = query2array($query);
+
+  if (count($subscriptions)==0)
+  {
+    return;
+  }
+
   set_make_full_url();
-  
+
   // get element infos
   if ($element_type == 'image')
@@ -81,14 +86,15 @@
     $element = get_category_infos($comm['category_id']);
   }
-  
+
   // format comment
-  if ($comm['author'] == 'guest') $comm['author'] = l10n('guest');
+  if ($comm['author'] == 'guest')
+  {
+    $comm['author'] = l10n('guest');
+  }
+
   $comm['author'] = trigger_event('render_comment_author', $comm['author']);
   $comm['content'] = trigger_event('render_comment_content', $comm['content']);
-  
-  // mail content
-  $subject = '['.strip_tags($conf['gallery_title']).'] Re:'.$element['name'];
-    
-  $template->set_filename('stc_mail', realpath(SUBSCRIBE_TO_PATH . 'template/mail/notification.tpl'));
+
+  include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
 
   foreach ($subscriptions as $row)
@@ -103,5 +109,5 @@
       $row['user_id'] = $conf['guest_id'];
     }
-    
+
     // check permissions
     if (!user_can_view_element($row['user_id'], $element_id, $element_type))
@@ -109,25 +115,29 @@
       continue;
     }
-    
-    // send mail
-    switch_lang_to($row['language']);
-    load_language('plugin.lang', SUBSCRIBE_TO_PATH);
-    
-    $comm['caption'] = sprintf('<b>%s</b> wrote on <i>%s</i>', $comm['author'], format_date(date('Y-m-d H:i:s')));
-    
-    $template->assign('STC', array(
-      'element' => $element,
-      'comment' => $comm,
-      'UNSUB_URL' => make_stc_url('unsubscribe', $row['email'], $row['id']),
-      'MANAGE_URL' => make_stc_url('manage', $row['email']),
-      'GALLERY_TITLE' => $conf['gallery_title'],
-      ));
-    
-    $content = $template->parse('stc_mail', true);
-
-    stc_send_mail($row['email'], $content, $subject);
+
+    switch_lang_to($language);
+
+    $comm['date'] = format_date(date('Y-m-d H:i:s'));
+
+    pwg_mail(
+      $row['email'],
+      array(
+        'subject' => '['.strip_tags($conf['gallery_title']).'] Re:'.$element['name'],
+        ),
+      array(
+        'filename' => 'notification',
+        'dirname' => SUBSCRIBE_TO_PATH . 'template',
+        'assign' => array(
+          'ELEMENT' => $element,
+          'COMMENT' => $comm,
+          'UNSUB_URL' => make_stc_url('unsubscribe', $row['email'], $row['id']),
+          'MANAGE_URL' => make_stc_url('manage', $row['email']),
+          ),
+        )
+      );
+
     switch_lang_back();
   }
-  
+
   load_language('plugin.lang', SUBSCRIBE_TO_PATH);
   unset_make_full_url();
@@ -149,30 +159,30 @@
     return false;
   }
-  
-  if ( !in_array($type, array('all-images','all-albums')) and $element_id == 'NULL' )
+
+  if (!in_array($type, array('all-images','all-albums')) and $element_id == 'NULL')
   {
     trigger_error('subscribe_to_comment: missing element_id', E_USER_WARNING);
     return false;
   }
-  
+
   global $page, $conf, $user, $template, $picture;
-  
+
   // check email
-  if ( !empty($email) and !email_check_format($email) )
-  {
-    array_push($page['errors'], l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)'));
-    return false;
-  }
-  if ( ( is_a_guest() or empty($user['email']) ) and empty($email) )
-  {
-    array_push($page['errors'], l10n('Invalid email adress, your are not subscribed to comments.'));
-    return false;
-  }
-  else if ( !is_a_guest() and empty($email) )
+  if (!empty($email) and !email_check_format($email))
+  {
+    $page['errors'][] = l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)');
+    return false;
+  }
+  if ( (is_a_guest() or empty($user['email'])) and empty($email) )
+  {
+    $page['errors'][] = l10n('Invalid email address, your are not subscribed to comments.');
+    return false;
+  }
+  else if (!is_a_guest() and empty($email))
   {
     $email = $user['email'];
   }
-  
-  // search if already registered (can't use ODKU because we want to get the id of inserted OR updated row)
+
+  // search if already registered
   $query = '
 SELECT id
@@ -184,12 +194,11 @@
 ;';
   $result = pwg_query($query);
-  
+
   if (pwg_db_num_rows($result))
   {
-    list($inserted_id) = pwg_db_fetch_row($result);
-  }
-  else
-  {
-    $query = '
+    return false;
+  }
+
+  $query = '
 INSERT INTO '.SUBSCRIBE_TO_TABLE.'(
     type,
@@ -209,33 +218,23 @@
   )
 ;';
-    pwg_query($query);
-    
-    $inserted_id = pwg_db_insert_id();
-  }
-  
-  // notify admins
-  if ( pwg_db_changes() != 0 and $conf['Subscribe_to_Comments']['notify_admin_on_subscribe'] )
-  {
-    stc_mail_notification_admins($email, $type, $element_id, $inserted_id);
-  }
-  
-  // send validation mail
-  if ( is_a_guest() and pwg_db_changes() != 0 )
-  {
-    set_make_full_url();
-    
-    $template->set_filename('stc_mail', realpath(SUBSCRIBE_TO_PATH . 'template/mail/confirm.tpl'));
-    
-    $subject = '['.strip_tags($conf['gallery_title']).'] '.l10n('Confirm your subscribtion to comments');
-      
+  pwg_query($query);
+
+  $stc_id = pwg_db_insert_id();
+
+  include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
+
+  set_make_full_url();
+
+  if (!is_a_guest() or $conf['Subscribe_to_Comments']['notify_admin_on_subscribe'])
+  {
     switch ($type)
     {
       case 'image':
         $element = get_picture_infos($element_id);
-        $element['on'] = sprintf(l10n('the picture <a href="%s">%s</a>'), $element['url'], $element['name']);
+        $element['on'] = l10n('the picture <a href="%s">%s</a>', $element['url'], $element['name']);
         break;
       case 'album-images':
         $element = get_category_infos($element_id);
-        $element['on'] = sprintf(l10n('all pictures of the album <a href="%s">%s</a>'), $element['url'], $element['name']);
+        $element['on'] = l10n('all pictures of the album <a href="%s">%s</a>', $element['url'], $element['name']);
         break;
       case 'all-images':
@@ -245,5 +244,5 @@
       case 'album':
         $element = get_category_infos($element_id);
-        $element['on'] = sprintf(l10n('the album <a href="%s">%s</a>'), $element['url'], $element['name']);
+        $element['on'] = l10n('the album <a href="%s">%s</a>', $element['url'], $element['name']);
         break;
       case 'all-albums':
@@ -252,28 +251,55 @@
         break;
     }
-    
-    $template->assign('STC', array(
-      'element' => $element,
-      'VALIDATE_URL' => make_stc_url('validate', $email, $inserted_id),
-      'MANAGE_URL' => make_stc_url('manage', $email),
-      'GALLERY_TITLE' => $conf['gallery_title'],
-      ));
-    
-    $content = $template->parse('stc_mail', true);
-
-    stc_send_mail($email, $content, $subject);
-    unset_make_full_url();
-    
-    array_push($page['infos'], l10n('Please check your email inbox to confirm your subscription.'));
-    return true;
+  }
+
+  // send validation mail
+  if (is_a_guest())
+  {
+    pwg_mail(
+      $email,
+      array(
+        'subject' => '['.strip_tags($conf['gallery_title']).'] '.l10n('Confirm your subscription to comments'),
+        ),
+      array(
+        'filename' => 'confirm',
+        'dirname' => SUBSCRIBE_TO_PATH . 'template',
+        'assign' => array(
+          'ELEMENT' => $element,
+          'VALIDATE_URL' => make_stc_url('validate', $email, $stc_id),
+          'MANAGE_URL' => make_stc_url('manage', $email),
+          ),
+        )
+      );
+
+    $page['infos'][] = l10n('Please check your email in-box to confirm your subscription.');
   }
   // just display confirmation message
-  else if (pwg_db_changes() != 0)
-  {
-    array_push($page['infos'], l10n('You have been added to the list of subscribers.'));
-    return true;
-  }
-  
-  return false;
+  else
+  {
+    $page['infos'][] = l10n('You have been added to the list of subscribers.');
+  }
+
+  // notify admins
+  if ($conf['Subscribe_to_Comments']['notify_admin_on_subscribe'])
+  {
+    $keyargs_content = array(
+      get_l10n_args('Hi administrators,'),
+      get_l10n_args(''),
+      get_l10n_args('%s has subscribed to comments on %s.', array($email, $element['on'])),
+      get_l10n_args('', ''),
+      get_l10n_args('Connected user: %s', stripslashes($user['username'])),
+      get_l10n_args('IP: %s', $_SERVER['REMOTE_ADDR']),
+      get_l10n_args('Browser: %s', $_SERVER['HTTP_USER_AGENT']),
+      );
+
+    pwg_mail_notification_admins(
+      get_l10n_args('%s has subscribed to comments on %s.', array($email, '')),
+      $keyargs_content
+      );
+  }
+
+  unset_make_full_url();
+
+  return true;
 }
 
@@ -285,39 +311,44 @@
  * @return: bool
  */
-function un_subscribe_to_comments($email, $id)
-{  
-  if ( !empty($email) and !email_check_format($email) )
+function un_subscribe_to_comments($email, $ids)
+{
+  if (!empty($email) and !email_check_format($email))
   {
     trigger_error('un_subscribe_to_comment: bad email', E_USER_WARNING);
     return false;
   }
-  
-  if (!preg_match('#^[0-9]+$#', $id))
+  if (empty($ids))
   {
     trigger_error('un_subscribe_to_comment: bad id', E_USER_WARNING);
     return false;
   }
-  
-  global $template, $user;
-  
+
+  global $user;
+
   // check email
-  if ( ( is_a_guest() or empty($user['email']) ) and empty($email) )
-  {
-    return false;
-  }
-  else if ( !is_a_guest() and empty($email) )
+  if ( (is_a_guest() or empty($user['email'])) and empty($email) )
+  {
+    return false;
+  }
+  else if (!is_a_guest() and empty($email))
   {
     $email = $user['email'];
   }
-  
+
+  if (!is_array($ids))
+  {
+    $ids = array($ids);
+  }
+  $ids = array_map('intval', $ids);
+
   // delete subscription
   $query = '
 DELETE FROM '.SUBSCRIBE_TO_TABLE.'
-  WHERE 
+  WHERE
     email = "'.pwg_db_real_escape_string($email).'"
-    AND id = '.$id.'
+    AND id IN('. implode(',', $ids) .')
 ;';
   pwg_query($query);
-  
+
   return (pwg_db_changes() != 0);
 }
@@ -330,5 +361,5 @@
  * @return: bool
  */
-function validate_subscriptions($email, $id)
+function validate_subscriptions($email, $ids)
 {
   if (!email_check_format($email))
@@ -337,86 +368,26 @@
     return false;
   }
-  
-  if (!preg_match('#^[0-9]+$#', $id))
+  if (empty($ids))
   {
     trigger_error('validate_subscriptions: bad id', E_USER_WARNING);
     return false;
   }
-  
+
+  if (!is_array($ids))
+  {
+    $ids = array($ids);
+  }
+  $ids = array_map('intval', $ids);
+
   $query = '
 UPDATE '.SUBSCRIBE_TO_TABLE.'
   SET validated = "true"
-  WHERE 
+  WHERE
     email = "'.pwg_db_real_escape_string($email).'"
-    AND id = '.$id.'
+    AND id IN('. implode(',', $ids) .')
 ;';
   pwg_query($query);
-  
+
   return (pwg_db_changes() != 0);
-}
-
-
-/**
- * send notification to admins
- * @param: string email
- * @param: string type (image|album-images|all-images|album|all-albums)
- * @param: int element_id
- * @param: int subscription id
- */
-function stc_mail_notification_admins($email, $type, $element_id, $inserted_id)
-{
-  global $user, $conf, $template;
-  
-  $admins = get_admins_email();
-  if (empty($admins)) return;
-  
-  set_make_full_url();
-  switch_lang_to(get_default_language());
-  load_language('plugin.lang', SUBSCRIBE_TO_PATH);
-  
-  $template->set_filename('stc_mail', realpath(SUBSCRIBE_TO_PATH . 'template/mail/admin.tpl'));
-    
-  $subject = '['.strip_tags($conf['gallery_title']).'] '.sprintf(l10n('%s has subscribed to comments on %s.'), is_a_guest()?$email:$user['username'], null);
-    
-  switch ($type)
-  {
-    case 'image':
-      $element = get_picture_infos($element_id, false);
-      $element['on'] = sprintf(l10n('the picture <a href="%s">%s</a>'), $element['url'], $element['name']);
-      break;
-    case 'album-images':
-      $element = get_category_infos($element_id, false);
-      $element['on'] = sprintf(l10n('all pictures of the album <a href="%s">%s</a>'), $element['url'], $element['name']);
-      break;
-    case 'all-images':
-      $element['on'] = l10n('all pictures of the gallery');
-      break;
-    case 'album':
-      $element = get_category_infos($element_id, false);
-      $element['on'] = sprintf(l10n('the album <a href="%s">%s</a>'), $element['url'], $element['name']);
-      break;
-    case 'all-albums':
-      $element['on'] = l10n('all albums of the gallery');
-      break;
-  }
-  
-  $technical_infos[] = sprintf(l10n('Connected user: %s'), stripslashes($user['username']));
-  $technical_infos[] = sprintf(l10n('IP: %s'), $_SERVER['REMOTE_ADDR']);
-  $technical_infos[] = sprintf(l10n('Browser: %s'), $_SERVER['HTTP_USER_AGENT']);
-  
-  $template->assign('STC', array(
-    'ELEMENT' => $element['on'],
-    'USER' => is_a_guest() ? '<b>'.$email.'</b>' : '<b>'.$user['username'].'</b> ('.$email.')', 
-    'GALLERY_TITLE' => $conf['gallery_title'],
-    'TECHNICAL' => implode('<br>', $technical_infos),
-    ));
-  
-  $content = $template->parse('stc_mail', true);
-
-  stc_send_mail($admins, $content, $subject);
-  
-  unset_make_full_url();
-  switch_lang_back();
-  load_language('plugin.lang', SUBSCRIBE_TO_PATH);
 }
 
@@ -431,115 +402,31 @@
 function make_stc_url($action, $email, $id=null)
 {
-  if ( empty($action) or empty($email) )
+  if (empty($action) or empty($email))
   {
     trigger_error('make_stc_url: missing action and/or mail', E_USER_WARNING);
     return null;
   }
-  
+
   global $conf;
   set_make_full_url();
-  
-  $url_params = array(
-    'action' => $action,
-    'email' => $email,
-    );
-  
+
+  $url_params = compact('action', 'email');
   if (!empty($id))
   {
     $url_params['id'] = $id;
   }
-  
+
   $url_params['key'] = crypt_value(
-    $action.$email.(isset($url_params['id'])?$url_params['id']:null), 
+    $action.$email.$id,
     $conf['secret_key']
     );
-  
+
   $url = add_url_params(
-    make_index_url( array('section' => 'subscriptions') ),
+    make_index_url(array('section' => 'subscriptions')),
     $url_params
     );
-    
+
   unset_make_full_url();
   return $url;
-}
-
-
-/**
- * send mail with STC style
- * @param: string to
- * @param: string content
- * @param: string subject
- * @return: bool
- */
-function stc_send_mail($to, $content, $subject)
-{
-  global $conf, $conf_mail, $page, $template;
-  
-  // inputs
-  if (empty($to))
-  {
-    return false;
-  }
-
-  if (empty($content))
-  {
-    return false;
-  }
-  
-  if (empty($subject))
-  {
-    $subject = 'Piwigo';
-  }
-  else
-  {
-    $subject = trim(preg_replace('#[\n\r]+#s', '', $subject));
-    $subject = encode_mime_header($subject);
-  }
-  
-  if (!isset($conf_mail))
-  {
-    $conf_mail = get_mail_configuration();
-  }
-
-  $args['from'] = $conf_mail['formated_email_webmaster'];
-  
-  set_make_full_url();
-  
-  // hearders
-  $headers = 'From: '.$args['from']."\n";  
-  $headers.= 'MIME-Version: 1.0'."\n";
-  $headers.= 'X-Mailer: Piwigo Mailer'."\n";
-  $headers.= 'Content-Transfer-Encoding: 8bit'."\n";
-  $headers.= 'Content-Type: text/html; charset="'.get_pwg_charset().'";'."\n";
-  
-  // template
-  $template->set_filenames(array(
-    'stc_mail_header' => realpath(SUBSCRIBE_TO_PATH . 'template/mail/header.tpl'),
-    'stc_mail_footer' => realpath(SUBSCRIBE_TO_PATH . 'template/mail/footer.tpl'),
-    ));
-  $stc_mail_css = file_get_contents(realpath(SUBSCRIBE_TO_PATH . 'template/mail/style.css'));
-    
-  $template->assign(array(
-    'GALLERY_URL' => get_gallery_home_url(),
-    'PHPWG_URL' => PHPWG_URL,
-    'STC_MAIL_CSS' => str_replace("\n", null, $stc_mail_css),
-    ));
-  
-  $content = $template->parse('stc_mail_header', true) . $content . $template->parse('stc_mail_footer', true);
-  
-  $content = wordwrap($content, 70, "\n", false);
-
-  unset_make_full_url();
-  
-  // send mail
-  return
-    trigger_event('send_mail',
-      false, /* Result */
-      trigger_event('send_mail_to', get_strict_email_list($to)),
-      trigger_event('send_mail_subject', $subject),
-      trigger_event('send_mail_content', $content),
-      trigger_event('send_mail_headers', $headers),
-      $args
-    );
 }
 
@@ -553,6 +440,9 @@
 function get_picture_infos($image_id, $with_thumb=true)
 {
-  if (empty($image_id)) return array();
-  
+  if (empty($image_id))
+  {
+    return array();
+  }
+
   $query = '
 SELECT
@@ -565,5 +455,5 @@
 ;';
   $element = pwg_db_fetch_assoc(pwg_query($query));
-    
+
   if (empty($element['name']))
   {
@@ -571,14 +461,14 @@
   }
   $element['name'] = trigger_event('render_element_name', $element['name']);
-  
+
   $element['url'] = make_picture_url(array(
     'image_id'=>$element['id']
     ));
-  
+
   if ($with_thumb)
   {
     $element['thumbnail'] = DerivativeImage::thumb_url($element);
   }
-  
+
   return $element;
 }
@@ -593,7 +483,10 @@
 {
   global $conf;
-  
-  if ($user_id===null) $user_id = $conf['guest_id'];
-  
+
+  if ($user_id===null)
+  {
+    $user_id = $conf['guest_id'];
+  }
+
   $query = '
 SELECT
@@ -606,5 +499,5 @@
     img.path
   FROM '.CATEGORIES_TABLE.' AS cat
-    LEFT JOIN '.USER_CACHE_CATEGORIES_TABLE.' AS ucc 
+    LEFT JOIN '.USER_CACHE_CATEGORIES_TABLE.' AS ucc
       ON ucc.cat_id = cat.id AND ucc.user_id = '.$user_id.'
     LEFT JOIN '.IMAGES_TABLE.' AS img
@@ -613,12 +506,12 @@
 ;';
   $element = pwg_db_fetch_assoc(pwg_query($query));
-  
+
   $element['url'] = make_index_url(array(
     'section'=>'categories',
     'category'=>$element,
     ));
-    
+
   $element['name'] = trigger_event('render_category_name', $element['name']);
-  
+
   if ($with_thumb)
   {
@@ -636,5 +529,5 @@
     }
   }
-  
+
   return $element;
 }
@@ -647,7 +540,7 @@
 {
   global $conf, $user;
-  
+
   $admins = array();
-  
+
   $query = '
 SELECT
@@ -655,5 +548,5 @@
     u.'.$conf['user_fields']['email'].' AS email
   FROM '.USERS_TABLE.' AS u
-    JOIN '.USER_INFOS_TABLE.' AS i 
+    JOIN '.USER_INFOS_TABLE.' AS i
       ON i.user_id =  u.'.$conf['user_fields']['id'].'
   WHERE i.status IN ("webmaster", "admin")
@@ -686,10 +579,10 @@
 {
   global $conf;
-  
+
   $old_conf = $conf['external_authentification'];
   $conf['external_authentification'] = false;
   $user = getuserdata($user_id, true);
   $conf['external_authentification'] = $old_conf;
-  
+
   if ($type == 'image')
   {
@@ -715,5 +608,5 @@
  */
 function crypt_value($value, $key)
-{  
+{
   if (extension_loaded('mcrypt'))
   {
@@ -733,7 +626,7 @@
     }
   }
-  
+
   $result = base64url_encode($result);
-  return trim($result); 
+  return trim($result);
 }
 
@@ -746,6 +639,6 @@
 function decrypt_value($value, $key)
 {
-  $value = base64url_decode($value); 
-  
+  $value = base64url_decode($value);
+
   if (extension_loaded('mcrypt'))
   {
@@ -765,5 +658,5 @@
     }
   }
-  
+
   return trim($result);
 }
@@ -773,12 +666,13 @@
  * http://php.net/manual/en/function.base64-encode.php#103849
  */
-function base64url_encode($data)
-{
-  return rtrim(strtr(base64_encode($data), '+/', '-_'), '=');
-}
-function base64url_decode($data)
-{
-  return base64_decode(str_pad(strtr($data, '-_', '+/'), strlen($data) % 4, '=', STR_PAD_RIGHT));
-} 
-
-?>
+if (!function_exists('base64url_encode'))
+{
+  function base64url_encode($data)
+  {
+    return rtrim(strtr(base64_encode($data), '+/', '-_'), '=');
+  }
+  function base64url_decode($data)
+  {
+    return base64_decode(str_pad(strtr($data, '-_', '+/'), strlen($data) % 4, '=', STR_PAD_RIGHT));
+  }
+}
Index: /extensions/Subscribe_to_comments/include/subscriptions_page.inc.php
===================================================================
--- /extensions/Subscribe_to_comments/include/subscriptions_page.inc.php	(revision 26139)
+++ /extensions/Subscribe_to_comments/include/subscriptions_page.inc.php	(revision 26139)
@@ -0,0 +1,250 @@
+<?php
+defined('SUBSCRIBE_TO_PATH') or die('Hacking attempt!');
+
+global $template, $conf, $page, $user;
+
+// check input parameters
+if (empty($_GET['action']) or empty($_GET['email']) or empty($_GET['key']))
+{
+  $_GET['action'] = null;
+}
+else
+{
+  $verif_key = $_GET['action'].$_GET['email'].(isset($_GET['id'])?$_GET['id']:null);
+
+  if (decrypt_value($_GET['key'], $conf['secret_key']) !== $verif_key)
+  {
+    $_GET['action'] = null;
+  }
+}
+
+
+
+if (!empty($_GET['action']))
+{
+  // unsubscribe all
+  if (isset($_POST['unsubscribe_all']) and isset($_POST['unsubscribe_all_check']))
+  {
+    $query = '
+DELETE FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE email = "'.$_GET['email'].'"
+;';
+    pwg_query($query);
+  }
+
+  // bulk action
+  else if (isset($_POST['apply_bulk']) and !empty($_POST['selected']))
+  {
+    switch ($_POST['action'])
+    {
+      case 'unsubscribe':
+        un_subscribe_to_comments($_GET['email'], $_POST['selected']);
+        break;
+      case 'validate':
+        validate_subscriptions($_GET['email'], $_POST['selected']);
+        break;
+    }
+  }
+
+  // unsubscribe from manage page
+  else if (isset($_GET['unsubscribe']))
+  {
+    if (un_subscribe_to_comments($_GET['email'], $_GET['unsubscribe']))
+    {
+      $page['infos'][] = l10n('Successfully unsubscribed your email address from receiving notifications.');
+    }
+    else
+    {
+      $page['errors'][] = l10n('Not found.');
+    }
+  }
+
+  // validate from manage page
+  else if (isset($_GET['validate']))
+  {
+    if (validate_subscriptions($_GET['email'], $_GET['validate']))
+    {
+      $page['infos'][] = l10n('Your subscribtion has been validated, thanks you.');
+    }
+    else
+    {
+      $page['infos'][] = l10n('Already validated.');
+    }
+  }
+
+  $template->assign('MANAGE_LINK', make_stc_url('manage', $_GET['email']));
+}
+
+
+switch ($_GET['action'])
+{
+  /* validate */
+  case 'validate':
+  {
+    // don't need to sanitize inputs, already checked with the unique key
+    $query = '
+SELECT type, element_id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$_GET['email'].'"
+    AND id = '.$_GET['id'].'
+;';
+    $result = pwg_query($query);
+
+    if (!pwg_db_num_rows($result))
+    {
+      $page['errors'][] = l10n('Not found.');
+    }
+    else
+    {
+      if (validate_subscriptions($_GET['email'], $_GET['id']))
+      {
+        $page['infos'][] = l10n('Your subscription has been validated, thanks you.');
+      }
+      else
+      {
+        $page['infos'][] = l10n('Already validated.');
+      }
+
+      list($type, $element_id) = pwg_db_fetch_row($result);
+
+      switch ($type)
+      {
+        case 'image':
+          $element = get_picture_infos($element_id, false);
+          break;
+        case 'album-images':
+        case 'album':
+          $element = get_category_infos($element_id, false);
+          break;
+        default:
+          $element = null;
+      }
+
+      $template->assign(array(
+        'type' => $type,
+        'element' => $element,
+        ));
+    }
+
+    $template->assign('IN_VALIDATE', true);
+    break;
+  }
+
+  /* unsubscribe */
+  case 'unsubscribe':
+  {
+    $query = '
+SELECT
+    type,
+    element_id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$_GET['email'].'"
+    AND id = '.$_GET['id'].'
+;';
+    $result = pwg_query($query);
+
+    if (!pwg_db_num_rows($result))
+    {
+      $page['errors'][] = l10n('Not found.');
+    }
+    else
+    {
+      if (un_subscribe_to_comments($_GET['email'], $_GET['id']))
+      {
+        $page['infos'][] = l10n('Successfully unsubscribed your email address from receiving notifications.');
+      }
+      else
+      {
+        $page['errors'][] = l10n('Not found.');
+      }
+
+      list($type, $element_id) = pwg_db_fetch_row($result);
+
+      switch ($type)
+      {
+        case 'image':
+          $element = get_picture_infos($element_id);
+          break;
+        case 'album-images':
+        case 'album':
+          $element = get_category_infos($element_id);
+          break;
+        default:
+          $element = null;
+      }
+
+      $template->assign(array(
+        'type' => $type,
+        'element' => $element,
+        ));
+    }
+
+    $template->assign('IN_UNSUBSCRIBE', true);
+    break;
+  }
+
+  /* manage */
+  case 'manage':
+  {
+    $query = '
+SELECT *
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE email = "'.$_GET['email'].'"
+  ORDER BY registration_date DESC
+;';
+    $result = pwg_query($query);
+
+    if (pwg_db_num_rows($result))
+    {
+      while ($subscription = pwg_db_fetch_assoc($result))
+      {
+        $subscription['registration_date'] = format_date($subscription['registration_date'], true);
+
+        switch ($subscription['type'])
+        {
+          case 'image':
+            $subscription['infos'] = get_picture_infos($subscription['element_id']);
+            break;
+          case 'album-images':
+          case 'album':
+            $subscription['infos'] = get_category_infos($subscription['element_id'], true, $user['id']);
+            break;
+          default:
+            $subscription['infos'] = null;
+            $template->append('global_subscriptions', $subscription);
+            continue(2);
+        }
+
+        $template->append('subscriptions', $subscription);
+      }
+    }
+    else
+    {
+      $page['infos'][] = l10n('You are not subscribed to any comment.');
+    }
+    break;
+  }
+
+  default:
+  {
+    set_status_header(403);
+    $page['errors'][] = l10n('Bad query');
+  }
+}
+
+
+$template->assign(array(
+  'SUBSCRIBE_TO_PATH' => SUBSCRIBE_TO_PATH,
+  'SUBSCRIBE_TO_ABS_PATH' => realpath(SUBSCRIBE_TO_PATH).'/',
+  'COA_ACTIVATED' => defined('COA_ID'),
+  ));
+
+if (!empty($_GET['email']))
+{
+  $template->concat('TITLE', $conf['level_separator'] . l10n('Subscriptions of %s', '<i>'.$_GET['email'].'</i>'));
+}
+
+$template->set_filename('subscribe_to_comments', realpath(SUBSCRIBE_TO_PATH . 'template/subscriptions_page.tpl'));
+$template->assign_var_from_handle('CONTENT', 'subscribe_to_comments');
